#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <limits.h>
#include <time.h>
#include <string.h>

void print_matrix(int** m,int size)
{
	int i,j;
	for(i=0;i <size;i++)
		for(j=0;j <size;j++)
			if(j!=size-1)
				printf("%02d ",m[i][j]);
			else
				printf("%02d\n",m[i][j]);
}

int* cp_array(int a[],int left,int right)
{
	int len=right-left+1;
	int* res=malloc(len*sizeof(int));
	memcpy(res,a,len*sizeof(int));
	
	return res;
}

int* random_sorted_array(int size,int min_value,int delta,int seed)
{
	if(size==0)
		return NULL;
	
	/*1. setta il nuovo seed*/
	srand(seed);
	
	/*2. alloca dinamicamente lo spazio per l'array*/
	int* res_array =(int*) calloc(size,sizeof(int));
	
	/*3. genera un seq di SIZE numeri pseudo-random in ordine crescente*/
	int i;
	res_array[0] =min_value;
	for(i=1;i <size;i++)
		res_array[i]=res_array[i-1] + (rand() %(delta+1));
	
	return res_array;
}

int* random_array(int size,int min_value,int max_value,int seed)
{
	if(size==0)
		return NULL;

	int delta= max_value-min_value+1;
	
	/*1. setta il nuovo seed*/
	srand(seed);
	
	/*2. alloca dinamicamente lo spazio per l'array*/
	int* res_array =(int*) calloc(size,sizeof(int));
	
	/*3. genera un seq di SIZE numeri pseudo-random in [min_value..max_value] */
	int i;
	for(i=0;i <size;i++)
		res_array[i]=min_value + (rand() %delta);
	
	return res_array;
}

int equals(int a1[],int a2[],int from,int len)
{
	int i;
	int next =from;
	for(i=0;i <len;i++)
	{
		if(a1[next] != a2[next])
			return 0;
		next++;
	}
	
	return 1;
}

int is_sorted(int a[],int len)
{
	if(len<=1)
		return 1;
	
	int i;
	int lenMinus=len-1;
	for(i=0;i <lenMinus;i++)
	{
		if(a[i] >a[i+1])
			return 0;
	}
	
	return 1;
}

void print_array(int a[],int len)
{
	int i;
	for(i=0;i <len;i++)
		printf("%d ",a[i]);
		
	printf("\n");
}

void print_array2(int a[],int left,int right)
{
	int i;
	for(i=left;i <=right;i++)
		printf("%d ",a[i]);
		
	printf("\n");
}

//restituisce l'indice del valore minimo in a[left..right]
int find_min(int a[],int left,int right)
{
	int res=0;
	int min=INT_MAX;
	int i;
	for(i=left;i <=right;i++)
	{
		if(a[i] <=min)
		{
			min=a[i];
			res=i;
		}
	}
	
	return res;
}

void selection_sort(int a[],int len)
{
	int i,tmp;
	for(i=0;i <len;i++)
	{
		//1. seleziona il minimo in a[i..len-1]
		int min_idx=find_min(a,i,len-1);
		
		//2. scambia a[min_idx] <--> a[i]
		tmp=a[i];
		a[i]=a[min_idx];
		a[min_idx]=tmp;
	}
}
