#include <stdlib.h>
#include <stdio.h>

#include "queue.h"
#include "array_utils.h"
#include "io_utils.h"

int* bfs(int num_of_nodes,int** graph,int source)
{
	int* visited=calloc(num_of_nodes,sizeof(int));
	
	Queue* q=make_queue(2*num_of_nodes*num_of_nodes);
	enqueue(q,source);
	while(!empty(q))
	{
		int u=dequeue(q);
		if(!visited[u])
		{
			visited[u]=1; //a. marca il nodo 
			int v;
			//b. aggiunge in coda i vicini del nodo
			for(v=0;v<num_of_nodes;v++)
			{
				if(graph[u][v]!=0)
				{
					enqueue(q,v);
				}
				//else do nothing and continue
			}
		}
	}
	
	free_queue(&q);
	
	return visited;
}

int main(int argc,char** argv)
{
	if(argc!=4)
	{
		printf("USAGE: bfs <numOfNodes> <source> <edgesPath>\n");
		exit(1);
	}

	int num_of_nodes =atoi(argv[1]);
	int source =atoi(argv[2]);
	char* edges_path=argv[3];
	
	int** graph=read_edges(num_of_nodes,edges_path);
	printf("INPUT ---------------\n");
	print_matrix(graph,num_of_nodes);
	
	int* visited=bfs(num_of_nodes,graph,source);
	printf("OUTPUT ---------------\n");
	print_array(visited,num_of_nodes);
	
	return 0;
}
