#include <stdlib.h>
#include <stdio.h>
#include "queue.h"

Queue* make_queue(int array_size)
{
	Queue* q=calloc(1,sizeof(Queue));
	q->a=calloc(array_size,sizeof(int));
	q->arr_len=array_size;
	q->size=0;
	q->head=0;
	q->tail=array_size-1;
	
	return q;
}

void free_queue(Queue** q)
{
	Queue* queue=*q;
	free(queue->a);
	free(queue);
	*q=NULL;
}

int first(Queue* q)
{
	if(!empty(q))
	{
		return (q->a)[q->head];
	}
	else
	{
		printf("first(): empty(q) !!");
		exit(1);
	}
}

int empty(Queue* q)
{
	return ((q->size ==0) ? 1 : 0);
}

void enqueue(Queue* q,int x)
{
	if(q->size ==q->arr_len)
	{
		printf("enqueue(): no space !!");
		exit(1);
	}
	else
	{
		q->size =q->size+1;
		q->tail =(q->tail+1) % q->arr_len;
		(q->a)[q->tail] =x;
	}
}

int dequeue(Queue* q)
{
	if(!empty(q))
	{
		q->size =q->size -1;
		int res=q->a[q->head];
		q->head =(q->head+1) % q->arr_len;
		return res;
	}
	else
	{
		printf("dequeue(): empty(q) !!");
		exit(1);
	}
}

void print_queue(Queue* q)
{	
	int i,idx;
	int head=q->head;
	int size=q->size;
	int arr_len=q->arr_len;
	int* a=q->a;
	
	if(size==0)
	{
		printf("[]\n");
		return;
	}
	
	int idx_last=(head+size-1)%arr_len;
	for(i=0;i<size;i++)
	{
		idx=(head+i)%arr_len; //idx del prossimo elem da stampare
		if(idx==idx_last)
			printf("%d\n",a[idx]);
		else
			printf("%d ",a[idx]);
	}	
}
